# Hosting

## Installation

We currently support two installation methods for DSFX: Docker and manual installation.

### Docker

**pre-requisites**:

- docker

To run DSFX using Docker, you first need to log into the gitea registry. You can do this with the
following command.

```bash
export GITEA_PAT="hex string of pat created in gitea console"

echo $GITEA_PAT | docker login koti.casa -u <your-username> --password-stdin
```

Then, you can pull the DSFX image from the registry and run it.

```bash
docker run -d --name dsfx -p 8000:8000 koti.casa/numenorlabs/dsfx:latest
```

### Manual Installation

**pre-requisites**:

- go

To install DSFX manually, you need to clone the repository and compile the code. You can do this with
the following commands:

```bash
git clone https://koti.casa/numenor-labs/dsfx.git

cd dsfx

go build -o <installation-target> ./cmd/dsfx
```

## Environment Variables

DSFX uses the following environment variables to configure its behavior:

| Variable         | Description                                                 | Default Value    |
| ---------------- | ----------------------------------------------------------- | ---------------- |
| DSFX_HOST        | The host on which the DSFX server will run                  | 0.0.0.0          |
| DSFX_PORT        | The port on which the DSFX server will listen               | 8000             |
| DSFX_CONFIG_DIR  | The directory where the DSFX configuration files are stored | /etc/dsfx/config |
| DSFX_STORAGE_DIR | The directory where the DSFX storage files are stored       | /etx/dsfx/data   |

## Local Files

The DSFX server uses local files for configuration and storage. The default directories for these
files are specified in the `DSFX_CONFIG_DIR` and `DSFX_STORAGE_DIR` environment variables. You can
change these directories by setting the corresponding environment variables before starting the server.

For docker installations, it is recommended to mount the local directories to the container
using the `-v` flag. For example:

```bash
docker run -d \
    --name dsfx \
    -p 8000:8000 \
    -v /path/to/local/config:/etc/dsfx/config \
    -v /path/to/local/data:/etx/dsfx/data \
    koti.casa/numenorlabs/dsfx:latest
```
